#include<cstdio>
#include<algorithm>
#define infile "diamante.in"
#define outfile "diamante.out"
#define size 2000

using namespace std;

int case_number;
int a[size][size];
bool X[size],Y[size];

bool inside(int D, int x, int y){
	return (x+y >= -D && x+y <= D && x-y >= -D && x-y <= D && (x+y+11*D)%2 == 0);
}

void solve(){
	int D,i,j,x,y;
	
	scanf("%d",&D); D--;
	for(i=-D;i<=D;i++) for(j=-D;j<=D;j++) if(inside(D,i,j)) scanf("%d",&a[(size>>1)+i][(size>>1)+j]);
	
	for(i=-2*D;i<=2*D;i++) X[(size>>1)+i] = Y[(size>>1)+i] = true;
	for(i=-D;i<=D;i++) for(j=-D;j<=D;j++) if(inside(D,i,j)){
		for(x=-2*D;x<=2*D;x++) if(inside(D,2*x-i,j) && a[(size>>1)+i][(size>>1)+j] != a[(size>>1)+2*x-i][(size>>1)+j]) X[(size>>1)+x] = false;
		for(y=-2*D;y<=2*D;y++) if(inside(D,i,2*y-j) && a[(size>>1)+i][(size>>1)+j] != a[(size>>1)+i][(size>>1)+2*y-j]) Y[(size>>1)+y] = false;
	}
	
	int small = (1<<29);
	for(x=-2*D;x<=2*D;x++) for(y=-2*D;y<=2*D;y++) if(X[(size>>1)+x] && Y[(size>>1)+y]) small = min(small, D + 1 + abs(x) + abs(y));
	int ans = small*small - (D+1)*(D+1);
  printf("%d\n", ans);
}

int main(void){
	freopen("diamante.in", "r", stdin);
	freopen("diamante.out", "w", stdout);

  solve();

  fclose(stdin);
  fclose(stdout);
	return 0;
}
